"use strict";import ENV from"../env.js";import T from"../lib/tool.js";import MxWcStorage from"../lib/storage.js";import MxWcConfig from"../lib/config.js";import ExtApi from"../lib/ext-api.js";async function perform(){await migrateOldVersion(),await migrate()}async function migrate(){let t=await MxWcConfig.load();t=migrateConfig(t),await MxWcStorage.set("config",t),await migrateClippings(),await migrateCommands()}function migrateConfig(t,e={}){const n=t.version||MxWcConfig.defaultVersion,i=ConfigMigration[n];return i?migrateConfig(i(t),e):MxWcConfig.fixKeys(t,e)}const ConfigMigration={};async function migrateClippings(){await deleteClippingPaths()}async function deleteClippingPaths(){const t="mx-wc-clipping-migrated-delete-paths";if(await MxWcStorage.get(t,!1))console.info(t);else{const e=await MxWcStorage.get("clips",[]);e.forEach((t=>{delete t.paths})),await MxWcStorage.set("clips",e),await MxWcStorage.set(t,!0)}}async function migrateCommands(){await moveOldShortcutToSlot()}async function moveOldShortcutToSlot(){const t="mx-wc-command-migrated-move-old-shortcut-to-slot";if(await MxWcStorage.get(t,!1))return void console.info(t);const e=await ExtApi.getAllCommands();for(const t of e){let e,n;switch(t.name){case"open-clipping":e="slot-0",n=t.shortcut;break;case"clip-as-default":e="slot-1",n=t.shortcut;break;case"clip-as-html":e="slot-2",n=t.shortcut;break;case"clip-as-md":e="slot-3",n=t.shortcut}e&&n&&(await ExtApi.updateCommand({name:e,shortcut:n}),await ExtApi.updateCommand({name:t.name,shortcut:""}))}await MxWcStorage.set(t,!0)}async function migrateOldVersion(){await migrateV0134(),await migrateV0146(),await migrateV0147()}async function migrateV0134(){const{version:t}=ENV;if(T.isVersionGteq(t,"0.1.36"))return;const e="mx-wc-config-migrated-0.1.34";await MxWcStorage.get(e,!1)?console.info(e):(await migrateConfigToV0134(),await migrateStorageToV0134(),await MxWcStorage.set(e,!0))}async function migrateV0146(){const{version:t}=ENV,e="mx-wc-config-migrated-0.1.46";await MxWcStorage.get(e,!1)?console.info(e):(await migrateConfigToV0146(),await MxWcStorage.set(e,!0))}async function migrateV0147(){const{version:t}=ENV,e="mx-wc-config-migrated-0.1.47";await MxWcStorage.get(e,!1)?console.info(e):(await migrateConfigToV0147(),await MxWcStorage.set(e,!0))}async function migrateStorageToV0134(){const t=await MxWcStorage.get("downloadFold");t&&await MxWcStorage.set("downloadFolder",t)}async function migrateConfigToV0134(){const t=await MxWcConfig.load();t.clippingHandlerName&&(t.clippingHandler=T.capitalize(t.clippingHandlerName),"native-app"==t.clippingHandlerName&&(t.handlerNativeAppEnabled=!0),t.hotkeySwitchEnabled=t.enableSwitchHotkey,t.mouseModeEnabled=t.enableMouseMode,t.titleStyleClippingFolderFormat=t.titleClippingFolderFormat,t.titleStyleClippingFolderEnabled=t.saveTitleAsFoldName,t.assetPath=t.assetPath.replace("$CLIP-FOLD","$CLIPPING-PATH").replace("$MX-WC","$STORAGE-PATH"),t.clippingJsPath=t.clippingJsPath.replace("$MX-WC","$STORAGE-PATH"),await MxWcStorage.set("config",t),console.debug("0.1.34 migrate"))}async function migrateConfigToV0146(){const t=await MxWcConfig.load();if(t.titleStyleClippingFolderFormat){t.mainFileName="index.$FORMAT",t.saveTitleFile=!0,t.clippingFolderName="$YYYY-$MM-$DD-$TIME-INTSEC",t.saveTitleAsFilename&&(t.mainFileName="$TITLE.$FORMAT",t.saveTitleFile=!1),t.titleStyleClippingFolderEnabled&&(t.saveTitleFile=!1);let e=[];switch(t.defaultClippingFolderFormat){case"$FORMAT-B":e.push("$YYYY$MM$DD$HH$mm$SS");break;case"$FORMAT-C":e.push("$TIME-INTSEC");break;default:e.push("$YYYY-$MM-$DD-$TIME-INTSEC")}t.titleStyleClippingFolderEnabled&&("$FORMAT-B"===t.titleClippingFolderFormat?t.clippingFolderName="$TITLE":(e.push("$TITLE"),t.clippingFolderName=e.join("-"))),t.assetFolder=t.assetPath,t.htmlSaveClippingInformation=t.saveClippingInformation,t.mdSaveClippingInformation=t.saveClippingInformation,await MxWcStorage.set("config",t),console.debug("0.1.46 migrate")}}async function migrateConfigToV0147(){const t=await MxWcConfig.load();"$TITLE"===t.mainFileName&&(t.mainFileName="$TITLE.$FORMAT",await MxWcStorage.set("config",t)),console.debug("0.1.47 migrate")}ConfigMigration[2.13]=function(t){return t.version="2.14",t.userCommandsText='{\n  "doNothing": {"exec": "doNothing"}\n}',t},ConfigMigration[2.12]=function(t){return t.version="2.13",t.shortcutSlot0="_openLastClipping",t.shortcutSlot1="_clipAsDefault",t.shortcutSlot2="_clipAsHTML",t.shortcutSlot3="_clipAsMarkdown",t.shortcutSlot4="_doNothing",t.shortcutSlot5="_doNothing",t.shortcutSlot6="_doNothing",t.shortcutSlot7="_doNothing",t.shortcutSlot8="_doNothing",t.shortcutSlot9="_doNothing",t},ConfigMigration[2.11]=function(t){return t.version="2.12",t.selectSaveFormatOnMenus=t.inputFieldSaveFormatEnabled,delete t.inputFieldSaveFormatEnabled,t},ConfigMigration["2.10"]=function(t){return t.version="2.11",t.markdownOptionFormulaBlockWrapper="padSameLine",t},ConfigMigration[2.9]=function(t){return t.version="2.10",t.autoInputLastTags=!0,t},ConfigMigration[2.8]=function(t){return t.version="2.9",t.markdownOptionHeadingStyle="atx",t.markdownOptionHr="* * *",t.markdownOptionBulletListMarker="*",t.markdownOptionCodeBlockStyle="fenced",t.markdownOptionFence="```",t.markdownOptionEmDelimiter="_",t.markdownOptionStrongDelimiter="**",t.markdownOptionLinkStyle="inlined",t.markdownOptionLinkReferenceStyle="full",t.markdownOptionPreformattedCode=!1,t},ConfigMigration[2.7]=function(t){return t.version="2.8",delete t.saveIcon,delete t.saveWebFont,delete t.saveCssImage,delete t.customBodyBgCssEnabled,delete t.customBodyBgCssValue,t},ConfigMigration[2.6]=function(t){return t.version="2.7",t.htmlCustomBodyBgCssEnabled=t.customBodyBgCssEnabled,t.htmlCustomBodyBgCssValue=t.customBodyBgCssValue,t},ConfigMigration[2.5]=function(t){return t.version="2.6",delete t.htmlWebFontFilter,t.htmlWebFontFilterList="woff2|woff|otf|ttf",t},ConfigMigration[2.4]=function(t){return t.version="2.5",t.htmlWebFontFilter="woff,woff2",t},ConfigMigration[2.3]=function(t){return t.version="2.4",t.htmlCaptureEmbed="saveImage",t.htmlCaptureObject="saveImage",t},ConfigMigration[2.2]=function(t){return t.version="2.3",t.htmlCompressCss=!1,t},ConfigMigration[2.1]=function(t){return t.version="2.2",t.htmlCaptureCssRules="saveAll",t},ConfigMigration["2.0"]=function(t){t.version="2.1";const e=t=>t?"saveAll":"remove";return t.htmlCaptureIcon=e(t.saveIcon),t.htmlCaptureWebFont=e(t.saveWebFont),t.htmlCaptureCssImage=e(t.saveCssImage),t.htmlCaptureImage="saveAll",t},ConfigMigration[1.9]=function(t){return t.version="2.0",t.htmlCaptureAudio="remove",t.htmlCaptureVideo="remove",t.htmlCaptureApplet="remove",t.htmlCaptureEmbed="filter",t.htmlCaptureObject="filter",t.htmlEmbedFilter="<images>",t.htmlObjectFilter="<images>",t},ConfigMigration[1.8]=function(t){return t.version="1.9",t.autoRunContentScripts=!1,t},ConfigMigration[1.7]=function(t){return t.version="1.8",delete t.hotkeySwitchEnabled,delete t.mdSaveClippingInformation,delete t.mdFrontMatterEnabled,delete t.mdFrontMatterTemplate,t},ConfigMigration[1.6]=function(t){t.version="1.7";const e=["\n{{content}}\n"];if(t.mdSaveClippingInformation){const t="\n---------------------------------------------------\n\n{{i18n_original_url}}: [{{i18n_access}}]({{url}})\n\n{{i18n_created_at}}: {{createdAt}}\n\n{{i18n_category}}: {{category}}{{^category}}{{i18n_none}}{{/category}}\n\n{{i18n_tags}}: {{#trimFn}}{{#tags}}`{{.}}`, {{/tags}}{{/trimFn}}{{^tags}}{{i18n_none}}{{/tags}}\n";e.push(t)}if(t.mdFrontMatterEnabled)try{const n=/\$\{([^\$\}]+)\}/gm,i=t.mdFrontMatterTemplate.replace(n,((t,e)=>{let n=`{{${e}}}`;return"tags"==e&&(n="\n{{#tags}}\n - {{.}}\n{{/tags}}",n+="\n{{^tags}}\n - {{i18n_none}}\n{{/tags}}"),"category"==e&&(n+="{{^category}}{{i18n_none}}{{/category}}"),"title"==e&&(n+="{{^title}}-{{/title}}"),n}));e.unshift(i)}catch(t){}return t.markdownTemplate=e.join("\n\n"),t},ConfigMigration[1.5]=function(t){return t.version="1.6",t.assetFileName="$TIME-INTSEC-$MD5URL$EXT",t.frameFileName="$TIME-INTSEC-$MD5URL.frame.html",t},ConfigMigration[1.4]=function(t){return t.version="1.5",t.customBodyBgCssEnabled=!1,t.customBodyBgCssValue="",t},ConfigMigration[1.3]=function(t){return t.version="1.4",t.autoInputLastCategory=!0,t},ConfigMigration[1.2]=function(t){return t.version="1.3",t.requestCacheSize=80,t.requestCacheCss=!0,t.requestCacheImage=!0,t.requestCacheWebFont=!1,t},ConfigMigration[1.1]=function(t){return t.version="1.2",t},ConfigMigration["1.0"]=function(t){return t.version="1.1",t.backupSettingPageConfig=!0,t.backupHistoryPageConfig=!0,t.backupAssistantData=!0,t.backupSelectionData=!0,t},ConfigMigration["0.0"]=function(t){return t.version="1.0",t};export default{perform,migrateConfig};