"use strict";import Log from"../lib/log.js";import MxWcStorage from"../lib/storage.js";import SavingTool from"../saving/new-saving-tool.js";import{QWebChannel}from"../lib/qwebchannel.js";const state={isConnected:!1,objApp:null,objCom:null,tempPath:null};async function saveClipping(e,t){await setup(),await createDocTempDir(e);const n=new SavingTool.SaveClipping(e,t,{mode:SavingTool.SaveClipping.MODE.COMPLETE_WHEN_ALL_TASK_FINISHED});for(let t=0;t<e.tasks.length;t++){const a=e.tasks[t];try{await saveTask(a)?n.taskCompleted(a):n.taskFailed(a,"Failed to download.")}catch(e){n.taskFailed(a,e.message)}}saveToWizNotePlus(e,t)}async function saveToWizNotePlus(e,t){const n=e.info,a=[state.tempPath,n.clipId,"index.html"].join("/");if("md"===n.format){n.title=n.title+".md";const t=embedMarkdownIntoHtml(getMarkdownText(e.tasks),n.title,n.link);await state.objCom.SaveTextToFile(a,t,"utf-8")}let o=n.category;o=o.startsWith("/")?o:"/"+o,o=o.endsWith("/")?o:o+"/",o="/default/"==o?"":o;let i=n.tags;await state.objApp.DatabaseManager.CreateDocument(a,n.title,o,i,n.link)}function getMarkdownText(e){let t="";for(const n of e)"mainFileTask"==n.taskType&&"text/markdown"==n.mimeType&&(t=n.text);return t=t.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#039;").replace(/\n/g,"<br>").replace(/\t/g,"&nbsp;".repeat(4)).replace(/ /g,"&nbsp;"),t}function embedMarkdownIntoHtml(e,t,n){return`\n<!DOCTYPE html>\n<html>\n    \x3c!-- OriginalSrc: ${n} --\x3e\n    <head>\n        <meta http-equiv="Content-Type" content="text/html charset=UTF-8" />\n        <meta name="viewport" content="width=device-width, initial-scale=1.0" />\n        <title>${t}</title>\n    </head>\n    <body>\n        ${e}\n    </body>\n</html>`}async function getInfo(){try{return await setup(),{ready:!0,supportFormats:["html","md"]}}catch(e){return{ready:!1,message:e.message,supportFormats:["html","md"]}}}async function setup(){state.isConnected||(state.isConnected=!!await createWebChannel()),syncCategories(),syncTags()}async function createWebChannel(){return new Promise(((e,t)=>{const n="ws://localhost:8848";Log.info("Connecting to WebSocket server of WizNotePlus at "+n+".");let a=new WebSocket(n);a.onclose=function(){Log.error("web channel closed"),state.isConnected=!1},a.onerror=function(e){Log.error("web channel error: "+e),state.isConnected=!1,e.message="Web channel error, failed to connect to WizNotPlus.",t(e)},a.onopen=function(){Log.debug("WebSocket connected, setting up QWebChannel."),new QWebChannel(a,(async function(t){Log.debug("Web channel opened"),state.isConnected=!0,state.objApp=t.objects.WizExplorerApp,state.objCom=state.objApp.CommonUI,state.tempPath=[await state.objCom.GetSpecialFolder("TemporaryFolder"),"webclipping"].join("/"),window.WizExplorerApp=t.objects.WizExplorerApp,e(!0)}))}}))}async function syncCategories(){const e=state.objApp.Database;let t=await e.GetAllLocations(),n=await MxWcStorage.get("categories",[]);n=n.filter((e=>t.includes(e))),t=t.filter((e=>!n.includes(e))),n=[...n,...t],MxWcStorage.set("categories",n)}async function syncTags(){const e=state.objApp.Database;let t=await e.GetAllTags(),n=await MxWcStorage.get("tags",[]);n=n.filter((e=>t.includes(e))),t=t.filter((e=>!n.includes(e))),n=[...n,...t],MxWcStorage.set("tags",n)}function handleClippingResult(e){return e.url="file://"+e.filename,e}async function saveTask(e){if(void 0!==state.objCom.Base64ToFile)switch(Log.debug("Use browser network."),e.type){case"text":return await downloadTextToFile(e);case"url":return await fetchAndDownload(e)}else switch(Log.debug("Use WizNotePlus network."),e.type){case"text":return await downloadTextToFile(e);case"url":return await downloadUrlToFile(e)}}async function downloadTextToFile(e){const t=state.objCom,n=[state.tempPath,e.filename].join("/");return await t.SaveTextToFile(n,e.text,"utf-8")}async function downloadUrlToFile(e){const t=state.objCom,n=[state.tempPath,e.filename].join("/"),a=["gif","png","apng","jpg","svg","bmp","webp","ico"].includes(e.filename.split(".").pop());return await t.URLDownloadToFile(e.url,n,a)}async function downloadBlobToFile(e){const t=state.objCom,n=e.blob,a=[state.tempPath,e.filename].join("/"),o=await blobToBase64(n);return await t.Base64ToFile(o,a)}async function blobToBase64(e){return new Promise((t=>{const n=new FileReader;n.onloadend=function(){t(n.result.replace(/^data:.+;base64,/,""))},n.readAsDataURL(e)}))}async function fetchAndDownload(e,t){Log.debug("fetch",e.url);const n=await Global.TaskFetcher.get(e);return await downloadBlobToFile({blob:n,filename:e.filename},t)}async function createDocTempDir(e){const t=state.objCom,n=[state.tempPath,e.info.clipId,"index_files"].join("/");return await t.CreateDirectory(n)||Log.error("Faild to create directory at "+n),n}let Global=null;function init(e){Global=e}const ClippingHandler_WizNotePlus={name:"WizNotePlus",init,getInfo,saveClipping,handleClippingResult};export default ClippingHandler_WizNotePlus;