"use strict";import I18N from"../js/lib/translation.js";import Log from"../js/lib/log.js";import T from"../js/lib/tool.js";import MxWcTemplate from"../js/lib/template.js";import MxWcStorage from"../js/lib/storage.js";import MxWcConfig from"../js/lib/config.js";import FrameMsg from"../js/lib/frame-msg.js";import AutoComplete from"../js/lib/auto-complete.js";const ID="mx-wc-iframe-control",ID_SWITCH_BTN="switch-btn",CLASS_STATE_BAR="state-bar",CLASS_HINT="hint",ID_TITLE="title",ID_CATEGORY="category",ID_TAGSTR="tagstr",CLASS_FORM="save-form",CLASS_SAVE_BTN="save-button",CLASS_CANCEL_BTN="cancel-button",INPUT_TAG_NAMES=["INPUT","TEXTAREA"],CLASS_FORM_INPUTS=["save-form","input-group","actions"];function initUI(){const e=T.queryElem(".gbox"),t=T.findElem("ui-tpl").innerHTML;T.setHtml(e,t),setTimeout(initUIListener,0)}function initUIListener(){const e=getEntryBtn(),t=T.firstElem(CLASS_SAVE_BTN),n=T.firstElem(CLASS_CANCEL_BTN),s=T.findElem(ID_TITLE),i=T.findElem(ID_CATEGORY),o=T.findElem(ID_TAGSTR);T.bindOnce(e,"click",entryClick);const a=getStateBar();MxWcConfig.load().then((e=>{if(e.mouseModeEnabled&&a){a.classList.add("mouse-friendly");const e=T.firstElem("help");e.classList.add("mouse-friendly"),T.bindOnce(e,"click",keyboardClicked)}const t=T.queryElem(".op-btn-panel");T.bindOnce(t,"click",keyboardClicked)})),MxWcStorage.get("categories",[]).then((e=>{0==e.length&&a&&a.classList.add("new-user")})),T.bindOnce(t,"click",submitForm),T.bindOnce(n,"click",cancelForm),T.bindOnce(t,"keypress",formEnterKeyHandler),T.bindOnce(n,"keypress",formEnterKeyHandler),T.bindOnce(o,"keypress",formEnterKeyHandler),T.bindOnce(s,"keypress",formEnterKeyHandler),T.bindOnce(i,"keypress",formEnterKeyHandler),T.bindOnce(o,"focus",selectInputFieldValue),T.bindOnce(s,"focus",selectInputFieldValue),T.bindOnce(i,"focus",selectInputFieldValue),window.focus()}function keyboardClicked(e){if("KBD"===e.target.tagName.toUpperCase()){const t=parseInt(e.target.getAttribute("data-key-code"));if(t>-2e3)sendKeyPressMessage(t);else switch(t){case-2001:toggleOpBtnGroup();break;case-2002:showHelpModal()}}}function toggleOpBtnGroup(){const e="show",[t,n]=T.queryElems(".op-btn-group.group-b,.op-btn-group.group-c");t.classList.toggle(e),n.classList.toggle(e)}function showHelpModal(){const e=T.queryElem(".help-modal");e.style.display="block",T.bindOnce(e,"click",helpModalClicked)}function helpModalClicked(e){T.queryElem(".help-modal").style.display="none",stopEvent(e)}function initFrameMsg(){const e=atob(window.location.search.split("=")[1]);FrameMsg.init({id:ID,origin:window.location.origin,allowOrigins:[e]})}function listenFrameMsg(){FrameMsg.addListener("bindListener",bindListener),FrameMsg.addListener("unbindListener",unbindListener),FrameMsg.addListener("bindMouseMove",bindMouseMove),FrameMsg.addListener("unbindMouseMove",unbindMouseMove),FrameMsg.addListener("setStateIdle",setStateIdle),FrameMsg.addListener("setStateSelecting",setStateSelecting),FrameMsg.addListener("setStateSelected",setStateSelected),FrameMsg.addListener("setStateConfirmed",setStateConfirmed),FrameMsg.addListener("setStateClipping",setStateClipping),FrameMsg.addListener("setStateClipped",setStateClipped),FrameMsg.addListener("setSavingHint",setSavingHint),FrameMsg.addListener("setSavingStateStarted",setSavingStateStarted),FrameMsg.addListener("setSavingStateProgress",setSavingStateProgress),FrameMsg.addListener("setSavingStateCompleted",setSavingStateCompleted),FrameMsg.addListener("showForm",showForm),FrameMsg.addListener("hideForm",hideForm),FrameMsg.addListener("destroy",destroy)}function bindListener(e){bindMouseMove(),T.bind(document,"click",clickHandler,!0),T.bind(document,"keydown",keyDownHandler,!0)}function unbindListener(e){unbindMouseMove(),T.unbind(document,"click",clickHandler,!0),T.unbind(document,"keydown",keyDownHandler,!0)}function bindMouseMove(e){T.bind(document,"mousemove",mouseMoveHandler,!0)}function unbindMouseMove(e){T.unbind(document,"mousemove",mouseMoveHandler,!0)}function mouseMoveHandler(e){sendFrameMsgToTop("mousemove",{x:e.clientX,y:e.clientY})}function clickHandler(e){["HTML","BODY"].indexOf(e.target.tagName.toUpperCase())>-1&&sendFrameMsgToTop("click",{x:e.clientX,y:e.clientY})}function keyDownHandler(e){[27,13,37,46,38,39,40].indexOf(e.keyCode)<0||(INPUT_TAG_NAMES.includes(e.target.tagName.toUpperCase())||CLASS_FORM_INPUTS.includes(e.target.parentNode.className)?Log.debug(e.target.tagName):sendKeyPressMessage(e.keyCode))}function sendKeyPressMessage(e){let t=null;switch(e){case 27:t="pressEsc";break;case 13:t="pressEnter";break;case 46:t="pressDelete";break;case 37:t="pressLeft";break;case 38:t="pressUp";break;case 39:t="pressRight";break;case 40:t="pressDown";break;case-1001:t="clickSelectedArea"}sendFrameMsgToTop(t)}function entryClick(){sendFrameMsgToTop("entryClick")}function setStateIdle(e){const t=getGbox();getEntryBtn().title=I18N.t("switch.title"),t.classList.remove("selecting","selected","confirmed","clipping","saving"),t.classList.add("idle"),setHint("-")}function setStateSelecting(e){const t=getGbox(),n=getEntryBtn();n.innerText="ON",n.title=I18N.t("switch.title"),t.classList.remove("idle","selected","confirmed"),t.classList.add("selecting"),setHint(I18N.t("hint.selecting"))}function setStateSelected(e){const t=getGbox(),n=getEntryBtn();n.innerText="ON",n.title=I18N.t("switch.title"),t.classList.remove("idle","selecting","confirmed"),t.classList.add("selected"),setHint(I18N.t("hint.selected"))}function setStateConfirmed(e){const t=getGbox();t.classList.remove("idle","selecting","selected"),t.classList.add("confirmed"),setHint("-")}function setStateClipping(e){const t=getGbox();t.classList.remove("idle","selecting","selected","confirmed"),t.classList.add("clipping"),setHint(I18N.t("hint.clipping"))}function setStateClipped(e){const t=getGbox();t.classList.remove("clipping"),t.classList.add("clipped"),setHint(I18N.t("hint.clipped"))}function setSavingHint(e){const t=getGbox();t.classList.remove("clipping"),t.classList.add("saving"),setHint(e)}function setSavingStateStarted(e){const t=getGbox();t.classList.remove("clipping"),t.classList.add("saving"),setHint(I18N.t("hint.saving.started"))}function setSavingStateProgress(e){let t=I18N.t("hint.saving.progress");t=t.replace("$finished",e.finished).replace("$total",e.total),setHint(t)}function setSavingStateCompleted(e){setHint(I18N.t("hint.saving.completed"))}function setHint(e){const t=T.queryElems(`.${CLASS_HINT}`);T.each(t,(function(t){T.setHtml(t,e)}))}function getContextNode(){let e=T.firstElem("desktop");return T.isElemVisible(window,e)?e:T.firstElem("mobile")}function selectInputFieldValue(e){e.target&&e.target.select()}function formEnterKeyHandler(e){if(13===e.keyCode){if(e.preventDefault(),[ID_TITLE,ID_CATEGORY].indexOf(e.target.id)>-1){const t=T.firstElem(CLASS_FORM),n=T.queryElems("input",t),s=n[[].indexOf.call(n,e.target)+1];s&&s.focus()}else e.target.classList.contains(CLASS_CANCEL_BTN)?cancelForm():submitForm();stopEvent(e)}}async function showForm(e){Log.debug("showForm");const{title:t,category:n,tagstr:s,titles:i,categories:o,tags:a,config:r}=e,l=T.firstElem(CLASS_FORM);if("block"==l.style.display)return!1;setStateConfirmed(),l.style.display="block";const c=T.findElem(ID_TITLE),d=T.findElem(ID_CATEGORY),m=T.findElem(ID_TAGSTR);if(c.value=t,d.value=n,""!==s)m.value=s;else if(r.autoInputLastTags){const e=await MxWcStorage.get("last-tags",[]);m.value=e.join(" ")}MxWc.form.clearAutoComplete();const g=i||[];MxWc.form.addAutoComplete(c,g);const u=o||await MxWcStorage.get("categories",[]);MxWc.form.addAutoComplete(d,u),""===n&&(r.autoInputLastCategory&&u.length>0&&(d.value=u[0]),d.focus());const p=a||await MxWcStorage.get("tags",[]);return MxWc.form.addAutoComplete(m,p,!0),""!==n&&m.focus(),!0}function submitForm(){hideForm(),unbindListener();const e=T.findElem(ID_TITLE),t=T.findElem(ID_CATEGORY),n=T.findElem(ID_TAGSTR);sendFrameMsgToTop("submitForm",{title:e.value,category:t.value,tagstr:n.value})}function cancelForm(){hideForm(),sendFrameMsgToTop("cancelForm")}function hideForm(e){Log.debug("hideForm"),T.firstElem(CLASS_FORM).style.display="none"}function destroy(e){sendFrameMsgToTop("frame.control.removeMe")}function getGbox(){return T.queryElem(".gbox")}function getStateBar(){const e=getContextNode();return T.firstElem(CLASS_STATE_BAR,e)}function getEntryBtn(){return T.findElem(ID_SWITCH_BTN)}function stopEvent(e){e.stopPropagation(),e.preventDefault()}function sendFrameMsgToTop(e,t){FrameMsg.send({to:"top",type:e,msg:t||{}})}const MxWc={};MxWc.form={autoCompleteObjs:[],titleAutoComplete:null,categoryAutoComplete:null,tagstrAutoComplete:null,addAutoComplete:function(e,t,n=!1){const s=I18N.t("hint.show-options"),i=new AutoComplete(e,t,{multiple:n,buttonCSSKlass:"awesomplete-helper-btn",buttonTitle:s});this.autoCompleteObjs.push(i)},clearAutoComplete:function(){this.autoCompleteObjs.forEach((e=>{e.destroy(),e=void 0})),this.autoCompleteObjs=[]}},initUI(),initFrameMsg(),listenFrameMsg(),Log.info("control layer ready..");